; SETTINGS.ASM
; The "settings" screen (eg sound test).

settings:
	ld a,(settings_lives)
	inc a
	ld (settings_lives),a

	call screen_off

	; Load the BBC Micro font:
	call vid_clear_vram
	call load_beeb_font

	xor a
	ld b,vdp_reg_scroll_y
	call vid_set_vdp_reg

	xor a
	call vid_goto_palette
	xor a
	out (vdp_data),a
	out (vdp_data),a
	ld a,%11111111
	out (vdp_data),a
	out (vdp_data),a


	ld de,vram_names+12+5*64
	ld hl,txt_settings
	call puts_tab


	ld de,vram_names+14+9*64
	ld hl,txt_music
	call puts_tab

	ld de,vram_names+14+10*64
	ld hl,txt_sound
	call puts_tab

	ld de,vram_names+14+11*64
	ld hl,txt_level
	call puts_tab

	ld de,vram_names+14+12*64
	ld hl,txt_lives
	call puts_tab

	ld de,vram_names+14+13*64
	ld hl,txt_difficulty
	call puts_tab

	call screen_on

settings_loop:

	call update_sound
;	call play_music
	call vid_wait_vblank
	
	ld hl,vram_names+12+9*64+32
	ld ix,settings_music
	ld b,5
	ld c,0
--:	push bc

	push hl
	call vid_goto_address
	ld a,(settings_item)
	cp c
	ld a,0
	jr nz,+
	ld a,'>'-$20
+:	out (vdp_data),a
	xor a
	out (vdp_data),a
	ld a,(ix+0)
	call disp_a

	pop hl
	ld de,64
	add hl,de

	inc ix

	pop bc
	inc c
	djnz --

	ld a,(start_button_tracker)
	ld b,a
	in a,(joystick)
	cp b
	jr z,no_joystick_change
	ld b,a
	ld (start_button_tracker),a

	ld hl,settings_item
	ld a,b
	and joy_up
	jr nz,+
	dec (hl)
+:	ld a,b
	and joy_down
	jr nz,+
	inc (hl)
+:
	ld c,5
	call lock_range

	ld a,(settings_item)
	ld l,a
	ld h,0
	ld de,settings_music
	add hl,de
	
	ld a,b
	and joy_left
	jr nz,+
	dec (hl)
+:	ld a,b
	and joy_right
	jr nz,+
	inc (hl)
+:

	push hl
	ld a,(settings_item)
	ld l,a
	ld h,0
	ld de,ranges
	add hl,de
	ld a,(hl)
	pop hl
	ld c,a
	call lock_range

	ld a,b
	and joy_1
	jr nz,+

	ld a,(settings_item)
	cp 1
	jr nz,++
	ld a,(settings_sound)
	call play_sound
++:
+:

no_joystick_change:

	in a,(start)
	and start_button


	jp nz,settings_loop

	ld a,(settings_lives)
	dec a
	cp $FF
	ret z
	ld (settings_lives),a

	call screen_off
	ret


lock_range:
	ld a,(hl)
	cp -1
	jr nz,+
	xor a
+:	cp c
	jr nz,+
	ld a,c
	dec a
+:	ld (hl),a
	ret

ranges:
.db 4
.db (sound_effect_table_end-sound_effect_table)/3
.db 22
.db 11
.db 2

txt_settings:
.db "Cheats/Configuration",0


txt_sound:
.db "Sound test",0
txt_music:
.db "Music test",0
txt_level:
.db "Start level",0
txt_lives:
.db "Initial lives",0
txt_difficulty:
.db "Infinite lives",0
     